# selectel-dns-api
Simple Selectel DNS API.

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import selectel_dns_api 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import selectel_dns_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import selectel_dns_api
from selectel_dns_api.rest import ApiException
from pprint import pprint

# Configure API key authorization: X-Token
selectel_dns_api.configuration.api_key['X-Token'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# selectel_dns_api.configuration.api_key_prefix['X-Token'] = 'Bearer'
# create an instance of the API class
api_instance = selectel_dns_api.DomainsApi()
body = selectel_dns_api.NewDomain() # NewDomain | Domain info for creation

try:
    # Create new domain
    api_response = api_instance.add_domain(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling DomainsApi->add_domain: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.selectel.ru/domains/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DomainsApi* | [**add_domain**](docs/DomainsApi.md#add_domain) | **POST** / | Create new domain
*DomainsApi* | [**delete_domain**](docs/DomainsApi.md#delete_domain) | **DELETE** /{domain_id} | Deletes a domain
*DomainsApi* | [**get_domain_by_id**](docs/DomainsApi.md#get_domain_by_id) | **GET** /{domain_id} | Find domain by ID
*DomainsApi* | [**get_domain_by_name**](docs/DomainsApi.md#get_domain_by_name) | **GET** /{domain_name} | Find domain by name
*DomainsApi* | [**get_domain_zone_file**](docs/DomainsApi.md#get_domain_zone_file) | **GET** /{domain_id}/export | Find domain by name
*DomainsApi* | [**get_domains**](docs/DomainsApi.md#get_domains) | **GET** / | Getting domains info
*DomainsApi* | [**update_domain**](docs/DomainsApi.md#update_domain) | **PATCH** /{domain_id} | Updates a domain
*PtrApi* | [**add_ptr_record**](docs/PtrApi.md#add_ptr_record) | **POST** /ptr | Create new PTR record
*PtrApi* | [**delete_ptr_record**](docs/PtrApi.md#delete_ptr_record) | **DELETE** /ptr/{ptr_id} | Deletes a PTR record
*PtrApi* | [**get_ptr_record_by_id**](docs/PtrApi.md#get_ptr_record_by_id) | **GET** /ptr/{ptr_id} | Find information about PTR record by ID
*PtrApi* | [**get_ptr_records**](docs/PtrApi.md#get_ptr_records) | **GET** /ptr | Getting PTR records
*PtrApi* | [**update_ptr_record**](docs/PtrApi.md#update_ptr_record) | **PUT** /ptr/{ptr_id} | Updates a PTR record
*RecordsApi* | [**add_resource_record**](docs/RecordsApi.md#add_resource_record) | **POST** /{domain_id}/records | Create resource records for domain
*RecordsApi* | [**batch_update_resources_records**](docs/RecordsApi.md#batch_update_resources_records) | **PATCH** /{domain_name}/records/batch_update | Mass update of domain&#39;s resources records
*RecordsApi* | [**delete_resource_record**](docs/RecordsApi.md#delete_resource_record) | **DELETE** /{domain_id}/records/{record_id} | Deletes a resource record
*RecordsApi* | [**get_resource_records_by_domain_id**](docs/RecordsApi.md#get_resource_records_by_domain_id) | **GET** /{domain_id}/records | Getting records info
*RecordsApi* | [**get_resource_records_by_domain_name**](docs/RecordsApi.md#get_resource_records_by_domain_name) | **GET** /{domain_name}/records | Find resource records info for domain by name
*RecordsApi* | [**update_resource_record**](docs/RecordsApi.md#update_resource_record) | **PUT** /{domain_id}/records/{record_id} | Updates a resource record
*TagsApi* | [**add_new_tag**](docs/TagsApi.md#add_new_tag) | **POST** /tags | Create new tag
*TagsApi* | [**delete_tag**](docs/TagsApi.md#delete_tag) | **DELETE** /tags/{tag_id} | Deletes a tag
*TagsApi* | [**get_tag_by_id**](docs/TagsApi.md#get_tag_by_id) | **GET** /tags/{tag_id} | Find information about tag by ID
*TagsApi* | [**get_tags**](docs/TagsApi.md#get_tags) | **GET** /tags | Getting tags
*TagsApi* | [**update_tag**](docs/TagsApi.md#update_tag) | **PUT** /tags/{tag_id} | Updates a tag


## Documentation For Models

 - [ApiResponse](docs/ApiResponse.md)
 - [BatchUpdateModel](docs/BatchUpdateModel.md)
 - [Domain](docs/Domain.md)
 - [NewDomain](docs/NewDomain.md)
 - [NewOrUpdatedPTRRecord](docs/NewOrUpdatedPTRRecord.md)
 - [NewOrUpdatedRecord](docs/NewOrUpdatedRecord.md)
 - [NewOrUpdatedTag](docs/NewOrUpdatedTag.md)
 - [PTRRecord](docs/PTRRecord.md)
 - [Record](docs/Record.md)
 - [Tag](docs/Tag.md)
 - [UpdatedDomain](docs/UpdatedDomain.md)


## Documentation For Authorization


## X-Token

- **Type**: API key
- **API key parameter name**: X-Token
- **Location**: HTTP header


## Author

info@mdsina.ru

