# coding: utf-8

"""
    Selectel DNS API

    Simple Selectel DNS API.

    OpenAPI spec version: 1.0.0
    Contact: info@mdsina.ru
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from __future__ import absolute_import

import sys
import os
import re

# python 2 and python 3 compatibility library
from six import iteritems

from ..configuration import Configuration
from ..api_client import ApiClient


class PtrApi(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        config = Configuration()
        if api_client:
            self.api_client = api_client
        else:
            if not config.api_client:
                config.api_client = ApiClient()
            self.api_client = config.api_client

    def add_ptr_record(self, body, **kwargs):
        """
        Create new PTR record
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_ptr_record(body, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param NewOrUpdatedPTRRecord body: PTR record info for creation (required)
        :return: PTRRecord
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.add_ptr_record_with_http_info(body, **kwargs)
        else:
            (data) = self.add_ptr_record_with_http_info(body, **kwargs)
            return data

    def add_ptr_record_with_http_info(self, body, **kwargs):
        """
        Create new PTR record
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.add_ptr_record_with_http_info(body, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param NewOrUpdatedPTRRecord body: PTR record info for creation (required)
        :return: PTRRecord
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method add_ptr_record" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params) or (params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `add_ptr_record`")


        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['X-Token']

        return self.api_client.call_api('/ptr', 'POST',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PTRRecord',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def delete_ptr_record(self, ptr_id, **kwargs):
        """
        Deletes a PTR record
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_ptr_record(ptr_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int ptr_id: ID of PTR record (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.delete_ptr_record_with_http_info(ptr_id, **kwargs)
        else:
            (data) = self.delete_ptr_record_with_http_info(ptr_id, **kwargs)
            return data

    def delete_ptr_record_with_http_info(self, ptr_id, **kwargs):
        """
        Deletes a PTR record
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.delete_ptr_record_with_http_info(ptr_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int ptr_id: ID of PTR record (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ptr_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_ptr_record" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ptr_id' is set
        if ('ptr_id' not in params) or (params['ptr_id'] is None):
            raise ValueError("Missing the required parameter `ptr_id` when calling `delete_ptr_record`")


        collection_formats = {}

        path_params = {}
        if 'ptr_id' in params:
            path_params['ptr_id'] = params['ptr_id']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = ['X-Token']

        return self.api_client.call_api('/ptr/{ptr_id}', 'DELETE',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type=None,
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_ptr_record_by_id(self, ptr_id, **kwargs):
        """
        Find information about PTR record by ID
        Returns a single PTR record
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ptr_record_by_id(ptr_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int ptr_id: ID of PTR record (required)
        :return: PTRRecord
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_ptr_record_by_id_with_http_info(ptr_id, **kwargs)
        else:
            (data) = self.get_ptr_record_by_id_with_http_info(ptr_id, **kwargs)
            return data

    def get_ptr_record_by_id_with_http_info(self, ptr_id, **kwargs):
        """
        Find information about PTR record by ID
        Returns a single PTR record
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ptr_record_by_id_with_http_info(ptr_id, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int ptr_id: ID of PTR record (required)
        :return: PTRRecord
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ptr_id']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ptr_record_by_id" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ptr_id' is set
        if ('ptr_id' not in params) or (params['ptr_id'] is None):
            raise ValueError("Missing the required parameter `ptr_id` when calling `get_ptr_record_by_id`")


        collection_formats = {}

        path_params = {}
        if 'ptr_id' in params:
            path_params['ptr_id'] = params['ptr_id']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = ['X-Token']

        return self.api_client.call_api('/ptr/{ptr_id}', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PTRRecord',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def get_ptr_records(self, **kwargs):
        """
        Getting PTR records
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ptr_records(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: list[PTRRecord]
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.get_ptr_records_with_http_info(**kwargs)
        else:
            (data) = self.get_ptr_records_with_http_info(**kwargs)
            return data

    def get_ptr_records_with_http_info(self, **kwargs):
        """
        Getting PTR records
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.get_ptr_records_with_http_info(callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :return: list[PTRRecord]
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = []
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_ptr_records" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # Authentication setting
        auth_settings = ['X-Token']

        return self.api_client.call_api('/ptr', 'GET',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='list[PTRRecord]',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)

    def update_ptr_record(self, ptr_id, body, **kwargs):
        """
        Updates a PTR record
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_ptr_record(ptr_id, body, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int ptr_id: ID of PTR record (required)
        :param NewOrUpdatedPTRRecord body: PTR record info for update (required)
        :return: PTRRecord
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('callback'):
            return self.update_ptr_record_with_http_info(ptr_id, body, **kwargs)
        else:
            (data) = self.update_ptr_record_with_http_info(ptr_id, body, **kwargs)
            return data

    def update_ptr_record_with_http_info(self, ptr_id, body, **kwargs):
        """
        Updates a PTR record
        
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please define a `callback` function
        to be invoked when receiving the response.
        >>> def callback_function(response):
        >>>     pprint(response)
        >>>
        >>> thread = api.update_ptr_record_with_http_info(ptr_id, body, callback=callback_function)

        :param callback function: The callback function
            for asynchronous request. (optional)
        :param int ptr_id: ID of PTR record (required)
        :param NewOrUpdatedPTRRecord body: PTR record info for update (required)
        :return: PTRRecord
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ptr_id', 'body']
        all_params.append('callback')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method update_ptr_record" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ptr_id' is set
        if ('ptr_id' not in params) or (params['ptr_id'] is None):
            raise ValueError("Missing the required parameter `ptr_id` when calling `update_ptr_record`")
        # verify the required parameter 'body' is set
        if ('body' not in params) or (params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `update_ptr_record`")


        collection_formats = {}

        path_params = {}
        if 'ptr_id' in params:
            path_params['ptr_id'] = params['ptr_id']

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.\
            select_header_accept(['application/json'])

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.\
            select_header_content_type(['application/json'])

        # Authentication setting
        auth_settings = ['X-Token']

        return self.api_client.call_api('/ptr/{ptr_id}', 'PUT',
                                        path_params,
                                        query_params,
                                        header_params,
                                        body=body_params,
                                        post_params=form_params,
                                        files=local_var_files,
                                        response_type='PTRRecord',
                                        auth_settings=auth_settings,
                                        callback=params.get('callback'),
                                        _return_http_data_only=params.get('_return_http_data_only'),
                                        _preload_content=params.get('_preload_content', True),
                                        _request_timeout=params.get('_request_timeout'),
                                        collection_formats=collection_formats)
